<%-- $Id: edit_mimetype.jsp 5812 2011-10-17 14:19:38Z nicklas $
	------------------------------------------------------------------
	Copyright (C) 2005 Nicklas Nordborg
	Copyright (C) 2006 Jari Häkkinen, Nicklas Nordborg, Martin Svensson

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------


	@author Nicklas
	@version 2.0
--%>
<%@ page pageEncoding="UTF-8" session="false"
	import="net.sf.basedb.core.Application"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.core.Permission"
	import="net.sf.basedb.core.MimeType"
	import="net.sf.basedb.core.ItemSubtype"
	import="net.sf.basedb.core.ItemQuery"
	import="net.sf.basedb.core.ItemResultList"
	import="net.sf.basedb.core.query.Hql"
	import="net.sf.basedb.core.query.Orders"
	import="net.sf.basedb.core.PermissionDeniedException"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.util.Values"
	import="net.sf.basedb.core.plugin.GuiContext"
	import="net.sf.basedb.clients.web.extensions.ExtensionsControl"
	import="net.sf.basedb.clients.web.extensions.JspContext"
	import="net.sf.basedb.clients.web.extensions.edit.EditUtil"
	import="net.sf.basedb.util.extensions.ExtensionsInvoker"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="t" uri="/WEB-INF/tab.tld" %>
<%
final Item itemType = Item.MIMETYPE;
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, null, null);
final int itemId = cc.getId();
final String ID = sc.getId();
final float scale = Base.getScale(sc);
final DbControl dc = sc.newDbControl();
try
{
	String title = null;
	MimeType mimeType = null;
	boolean readCurrentFileType = true;
	int currentFileTypeId = 0;
	boolean autoCompress = false;

	if (itemId == 0)
	{
		title = "Create mime type";
		cc.removeObject("item");
		currentFileTypeId = Values.getInt(cc.getPropertyValue("fileType"), 0);
		if (currentFileTypeId == 0)
		{
			currentFileTypeId = Values.getInt(cc.getRecent(Item.ITEMSUBTYPE.name(), 0), 0);
		}
		autoCompress = Values.getBoolean(cc.getPropertyValue("autoCompress"), autoCompress);
	}
	else
	{
		mimeType = MimeType.getById(dc, itemId);
		cc.setObject("item", mimeType);
		title = "Edit MIME type -- " + HTML.encodeTags(mimeType.getName() + " (" + mimeType.getExtension() + ")");
		autoCompress = mimeType.getAutoCompress();
		try
		{
			ItemSubtype ft = mimeType.getFileType();
			if (ft != null) currentFileTypeId = ft.getId();
		}
		catch (PermissionDeniedException ex)
		{
			readCurrentFileType = false;
		}
	}
	if (mimeType != null) mimeType.checkPermission(Permission.WRITE);
	
	// Query to retrieve file types
	final ItemQuery<ItemSubtype> fileTypeQuery = ItemSubtype.getQuery(Item.FILE);
	fileTypeQuery.order(Orders.asc(Hql.property("name")));
	fileTypeQuery.setCacheResult(true);
	
	final String clazz = "class=\"text\"";
	final String requiredClazz = "class=\"text required\"";
	JspContext jspContext = ExtensionsControl.createContext(dc, pageContext, GuiContext.item(itemType), mimeType);
	ExtensionsInvoker invoker = EditUtil.useEditExtensions(jspContext);
	%>
	<base:page type="popup" title="<%=title%>">
	<base:head scripts="tabcontrol.js" styles="tabcontrol.css">
		<ext:scripts context="<%=jspContext%>" />
		<ext:stylesheets context="<%=jspContext%>" />
		<script language="JavaScript">
		// Validate the "MimeType" tab
		function validateMimeType()
		{
			var frm = document.forms['mimeType'];
			if (Main.trimString(frm.name.value) == '')
			{
				alert("You must enter a MIME type");
				frm.name.focus();
				return false;
			}
			if (Main.trimString(frm.extension.value) == '')
			{
				alert("You must enter a file extension");
				frm.name.focus();
				return false;
			}
			return true;
		}

		// Submit the form
		function saveSettings()
		{
			var frm = document.forms['mimeType'];
			if (TabControl.validateActiveTab('settings'))
			{
				frm.submit();
			}
		}
		
		function init()
		{
			<%
			if (mimeType == null)
			{
				%>
				var frm = document.forms['mimeType'];
				frm.name.focus();
				frm.name.select();
				<%
			}
			%>
		}
		</script>
	</base:head>
	<base:body onload="init()">
		<p>
		<form action="index.jsp?ID=<%=ID%>" method="post" name="mimeType" onsubmit="return false;">
		<input type="hidden" name="cmd" value="UpdateItem">

		<h3 class="docked"><%=title%> <base:help tabcontrol="settings" /></h3>
		<t:tabcontrol id="settings" contentstyle="<%="height: "+(int)(scale*240)+"px;"%>" 
			position="bottom" remember="<%=mimeType != null%>"
			extensions="<%=invoker%>">
		<t:tab id="info" title="MIME type" validate="validateMimeType()" helpid="mimetype.edit">
			<table class="form" cellspacing=0>
			<tr>
				<td class="prompt">File extension</td>
				<td><input <%=requiredClazz%> type="text" name="extension" 
					value="<%=HTML.encodeTags(mimeType == null ? cc.getPropertyValue("extension") : mimeType.getExtension())%>" 
					size="40" maxlength="<%=MimeType.MAX_NAME_LENGTH%>"></td>
			</tr>
			<tr>
				<td class="prompt">MIME type</td>
				<td><input <%=requiredClazz%> type="text" name="name" 
					value="<%=HTML.encodeTags(mimeType == null ? Values.getString(cc.getPropertyValue("name"), "New MIME type") : mimeType.getName())%>" 
					size="40" maxlength="<%=MimeType.MAX_NAME_LENGTH%>"></td>
			</tr>
			<tr valign="top">
				<td class="prompt">File type</td>
				<td colspan="2">
					<select name="filetype_id" <%=!readCurrentFileType ? "disabled readonly class=\"disabled\"" : ""%>>
					<%
					if (!readCurrentFileType)
					{
						%>
						<option value="-1">- denied -
						<%
					}
					else
					{
						%>
						<option value="0">- none -
						<%
						ItemResultList<ItemSubtype> fileTypes = fileTypeQuery.list(dc);
						for (ItemSubtype fileType : fileTypes)
						{
							int id = fileType.getId();
							%>
							<option 
								value="<%=mimeType != null && id == currentFileTypeId ? -id : id%>" 
								<%=id == currentFileTypeId ? "selected" : ""%>
								><%=HTML.encodeTags(fileType.getName())%>
							<%
						}
					}
					%>
					</select>
				</td>
			</tr>
			<tr>
				<td class="prompt">Auto compress</td>
				<td>
					<input type="radio" name="autoCompress" id="autoCompressNo" value="0" 
						<%=!autoCompress ? "checked" : ""%>><label for="autoCompressNo">no</label>
					<input type="radio" name="autoCompress" id="autoCompressYes" value="1" 
						<%=autoCompress ? "checked" : ""%>><label for="autoCompressYes">yes</label>
					
					<%
					if (!Application.autoCompressionEnabled())
					{
						%>
						<base:note type="info" style="background: #ffffcc;">
							Auto-compression has been disabled in <code>base.config</code>
						</base:note>
						<%
					}
					%>
				</td>
			</tr>	
			<tr valign=top>
				<td class="prompt">Description</td>
				<td nowrap>
					<textarea <%=clazz%> rows="4" cols="40" name="description" wrap="virtual"
						><%=HTML.encodeTags(mimeType == null ? cc.getPropertyValue("description") : mimeType.getDescription())%></textarea>
					<a href="javascript:Main.zoom('Description', 'mimeType', 'description')"
						title="Edit in larger window"><base:icon image="zoom.gif" /></a>
				</td>
			</tr>
			</table>
			<div align=right>&nbsp;<i><base:icon image="required.gif" /> = required information</i></div>
		</t:tab>
		</t:tabcontrol>

		<table align="center">
		<tr>
			<td width="50%"><base:button onclick="saveSettings()" title="Save" /></td>
			<td width="50%"><base:button onclick="window.close()" title="Cancel" /></td>
		</tr>
		</table>
		</form>
	</base:body>
	</base:page>
	<%
}
finally
{
	if (dc != null) dc.close();
}
%>
