<%-- $Id: test_with_file.jsp 5812 2011-10-17 14:19:38Z nicklas $
	------------------------------------------------------------------
	Copyright (C) 2006 Johan Enell, Nicklas Nordborg
	Copyright (C) 2007 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

	@author Nicklas
	@version 2.0
--%>
<%@ page pageEncoding="UTF-8" session="false"
	contentType="text/html; charset=UTF-8"	
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.Config"
	import="net.sf.basedb.core.Location"
	import="net.sf.basedb.util.parser.FlatFileParser"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.util.Values"
	import="net.sf.basedb.plugins.util.Parameters"
	import="net.sf.basedb.clients.web.util.HTML"
	import="java.nio.charset.Charset"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="m" uri="/WEB-INF/menu.tld" %>

<%
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final String ID = sc.getId();
final DbControl dc = sc.newDbControl();
try
{
	String preQuote = "(?!\"x\"y)";
	String postQuote = "(?=\"x\"y)";
	%>
	<base:page type="popup" title="Test with file">
	<base:head scripts="plugin.js,menu.js,ajax.js,json2.js" styles="menu.css">
		<script language="JavaScript">
		var timer = 0;
		var inCall = false;
		function adjustIFrameSize()
		{
			if (inCall) return;
			inCall = true;
			var iframeElement = document.getElementById("idParsed");
			// Find the top coordinate of the IFrame
			var offsetTop = 1;
			var offsetTrail = iframeElement;
			while (offsetTrail)
			{
				offsetTop += offsetTrail.offsetTop;
				offsetTrail = offsetTrail.offsetParent;
			}
	
			// Find the browser window height
			var windowHeight = Main.getWindowHeight();
			
			// Set iframe height
			var height = windowHeight-offsetTop - 80 * getScale();
			iframeElement.height = height;
			
			var iframe = window.frames['parsed'];
			var width = Main.getWindowWidth(iframe);
			var parsedFile = iframe.document.getElementById('parsedFile.content');
			if (parsedFile) 
			{
				parsedFile.style.height = (height-40)+'px';
				parsedFile.style.width = (width-20)+'px';
			}
			inCall = false;
		}
		function setTimer()
		{
			if (inCall) return;
			if (timer) clearTimeout(timer);
			timer = setTimeout('adjustIFrameSize()', 150);
		}

		function browseOnClick()
		{
			var frm = document.forms['testwithfile'];
			var url = '../../filemanager/index.jsp?ID=<%=ID%>&cmd=SelectOne&title=Test+with+file&callback=setFileCallback';
			Main.openPopup(url, 'SelectFile', 1000, 700);
		}
		function setFileCallback(fileId, path)
		{
			var frm = document.forms['testwithfile'];
			frm.file_id.value = fileId;
			frm.path.value = path;
			updateCharset(fileId);
		}
		function updateCharset(fileId)
		{
			var request = Ajax.getXmlHttpRequest();
			if (request != null)
			{
				var url = '../../filemanager/files/ajax.jsp?ID=<%=ID%>&cmd=GetFileInfo&item_id=' + fileId;
				request.open("GET", url, true);
				Ajax.setReadyStateHandler(request, updateCharsetCallback);
				request.send(null);
			}
			return request != null;
		}
		function updateCharsetCallback(request)
		{
			var response = Ajax.parseJsonResponse(request.responseText);
			var charset = response.characterSet;
			if (charset)
			{
				var frm = document.forms['testwithfile'];
				Forms.selectListOption(frm.charset, charset);
			}
		}
		function showPredefined(event, menu)
		{
			Menu.toggleTopMenu(document.getElementById(menu), event.clientX, event.clientY); 
			event.cancelBubble = true;
		}
		var preQuote = '(?!")';
		var postQuote = '(?=")';
		var whiteSpaceOrQuote = '[\\s\\"]*';
		var notInsideQoute = '(?=(?:[^"]*"[^"]*")*(?![^"]*"))';
		function setRegexp(field, regexp)
		{
			var frm = document.forms['testwithfile'];
			frm[field].value = regexp;
		}
		function doParse()
		{
			var frm = document.forms['testwithfile'];
			if (Main.trimString(frm.path.value) == '')
			{
				frm.path.focus();
				alert('You must select a file');
				return false;
			}
			else if (Main.trimString(frm.dataSplitter.value) == '')
			{
				frm.dataSplitter.focus();
				alert('You must specify a data splitter regular expression');
				return false;
			}
			frm.submit();
		}
		
		var parameterNames = new Array();
		function init()
		{
			adjustIFrameSize();
			var frm = document.forms['testwithfile'];
			var configWin = window.opener;
			frm.path.value = configWin.getParameterValue('file');
			frm.header.value = configWin.getParameterValue('headerRegexp');
			frm.dataHeader.value = configWin.getParameterValue('dataHeaderRegexp');
			frm.dataSplitter.value = configWin.getParameterValue('dataSplitterRegexp');
			frm.dataFooter.value = configWin.getParameterValue('dataFooterRegexp');
			frm.ignore.value = configWin.getParameterValue('ignoreRegexp');
			frm.minDataColumns.value = configWin.getParameterValue('minDataColumns');
			frm.maxDataColumns.value = configWin.getParameterValue('maxDataColumns');
			frm.trimQuotes.checked = configWin.getParameterValue('trimQuotes') != 'false';
			Forms.selectListOption(frm.charset, configWin.getParameterValue('<%=Parameters.CHARSET_PARAMETER%>'));
			
			var allParameters = configWin.Parameters.allParameters;
			for (var i = 0; i < allParameters.length; i++)
			{
				var param = allParameters[i];
				if (param.name.search('Mapping') >= 0)
				{
					parameterNames[parameterNames.length] = param.name;
					Forms.createHidden(frm, 'mapping.'+param.name+'.label', param.label);
					Forms.createHidden(frm, 'mapping.'+param.name+'.expression', param.values.length == 0 ? '' : param.values[0]);
				}
			}
			if (parameterNames.length > 0)
			{
				Forms.createHidden(frm, 'mappingParameterNames', parameterNames.join(','));
			}
		}
		
		function saveSettings()
		{
			var frm = document.forms['testwithfile'];
			var configWin = window.opener;
			configWin.setParameterValue('file', frm.path.value);
			configWin.setParameterValue('headerRegexp', frm.header.value);
			configWin.setParameterValue('dataHeaderRegexp', frm.dataHeader.value);
			configWin.setParameterValue('dataSplitterRegexp', frm.dataSplitter.value);
			configWin.setParameterValue('dataFooterRegexp', frm.dataFooter.value);
			configWin.setParameterValue('ignoreRegexp', frm.ignore.value);
			configWin.setParameterValue('minDataColumns', frm.minDataColumns.value);
			configWin.setParameterValue('maxDataColumns', frm.maxDataColumns.value);
			configWin.setParameterValue('trimQuotes', frm.trimQuotes.checked ? 'true' : 'false');
			configWin.setParameterValue('<%=Parameters.CHARSET_PARAMETER%>', frm.charset[frm.charset.selectedIndex].value);
			for (var i = 0; i < parameterNames.length; i++)
			{
				var name = parameterNames[i];
				configWin.setParameterValue(name, frm['mapping.'+name+'.expression'].value);
			}
			window.close();
		}
		
		function setFormValue(field, value)
		{
			var frm = document.forms['testwithfile'];
			frm.elements[field].value = value;
		}
		
		</script>
	</base:head>
	<base:body attributes="onresize='setTimer();'" onload="init();">

	<m:menu 
		id="predefinedSplitters"
		style="display: none;">
	
		<m:menuitem 
			title="Tab" 
			onclick="setRegexp('dataSplitter', '\\\\t')"
			tooltip="Splits data on tab"
		/>
		<m:menuitem 
			title="Comma" 
			onclick="setRegexp('dataSplitter', ',')"
			tooltip="Splits data on comma"
		/>
		<m:menuitem 
			title="Semicolon" 
			onclick="setRegexp('dataSplitter', ';')"
			tooltip="Splits data on semicolon"
		/>
		<m:menuseparator />
		<m:menuitem 
			title="Tab with quotes" 
			onclick="setRegexp('dataSplitter', preQuote+'\\\\t'+postQuote)"
			tooltip="Splits data on tab, but only if it is has quotes before and after"
		/>
		<m:menuitem 
			title="Comma with quotes" 
			onclick="setRegexp('dataSplitter', preQuote+','+postQuote)"
			tooltip="Splits data on comma, but only if it is has quotes before and after"
		/>
		<m:menuitem 
			title="Semicolon with quotes" 
			onclick="setRegexp('dataSplitter', preQuote+';'+postQuote)"
			tooltip="Splits data on semicolon, but only if it is has quotes before and after"
		/>
		<m:menuseparator />
		<m:menuitem 
			title="Comma; ignored inside quotes" 
			onclick="setRegexp('dataSplitter', ','+notInsideQoute)"
			tooltip="Splits data on comma, but not if they are inside quotes"
		/>
		<m:menuitem 
			title="Semicolon; ignored inside quotes" 
			onclick="setRegexp('dataSplitter', ';'+notInsideQoute)"
			tooltip="Splits data on semicolon, but not if they are inside quotes"
		/>
	</m:menu>

	<m:menu 
		id="predefinedHeaders"
		style="display: none;">
		<m:menuitem 
			title="Key = value" 
			onclick="setRegexp('header', '(.+)=(.*)')"
			tooltip="Headers have a key and value separated by an equal sign"
		/>
		<m:menuitem
			title="Key = value; remove whitespace and quotes"
			onclick="setRegexp('header', whiteSpaceOrQuote + '(.+?)' + whiteSpaceOrQuote + '=' + whiteSpaceOrQuote + '(.*?)' + whiteSpaceOrQuote)"
			tooltip="Header have a key and value separated by an equal sign; whitespace and quotes are removed"
		/>
	</m:menu>
	
	<m:menu 
		id="predefinedIgnore"
		style="display: none;">
		<m:menuitem 
			title="# Comment" 
			onclick="setRegexp('ignore', '#.*')"
			tooltip="Ignore all lines starting with #"
		/>
		<m:menuitem 
			title="Empty line" 
			onclick="setRegexp('ignore', '\\\\s*')"
			tooltip="Ignore all lines that contains nothing but white-space"
		/>
	</m:menu>

		<form name="testwithfile" action="parse_file.jsp?ID=<%=ID%>" target="parsed" method="post" onsubmit="return false;">
		<input type="hidden" name="file_id" value="">

		<h3 class="docked">Test with file <base:help helpid="runplugin.testwithfile" /></h3>
		<div class="boxed">
			<table class="form">
			<tr valign="top">
				<td class="prompt">File to test</td>
				<td colspan="3">
					<table border="0" cellspacing="0" cellpadding="0">
						<tr>
						<td><input type="text" class="text required" name="path" size="60" value="">&nbsp;</td>
						<td><base:button 
								title="Browse&hellip;"
								onclick="browseOnClick()"
								/>
						</td>
						<td>&nbsp;</td>
						<td><base:button title="Parse the file" onclick="doParse()" image="gonext.gif"/></td>
						</tr>
					</table>
				</td>
			</tr>
			<tr valign="top">
				<td class="prompt">Lines to parse</td>
				<td>
					<input type="text" class="text" name="maxLines" size="12" maxlength="10"
						value="<%=FlatFileParser.DEFAULT_MAX_UNKNOWN_LINES%>"
						onkeypress="return Numbers.integerOnly(event)">
				</td>
				<td class="prompt">Character set</td>
				<td>
					<select name="charset">
					<%
					String defaultCharset = Config.getCharset();
					int numCommon = Config.getCommonCharsets().size();
					int i = 0;
					for (String charset : Config.getAllCharsets())
					{
						%>
						<option value="<%=charset%>" 
							<%=defaultCharset.equalsIgnoreCase(charset) ? "selected" : ""%> 
							<%=i==numCommon ? "style=\"border-top: 1px solid #666666;\"" : "" %>><%=charset%>
						<%
						i++;
					}
					%>
					</select>
				</td>
			</tr>
			<tr valign="top">
				<td class="prompt">Header regexp</td>
				<td>
					<table border="0" cellspacing="0" cellpadding="0">
					<tr>
					<td>
						<input type="text" class="text" name="header" size="40">&nbsp;
					</td>
					<td>
						<base:button title="Predefined&hellip;" 
							onclick="showPredefined(event, 'predefinedHeaders')" />
					</td>
					</tr>
					</table>
				</td>
				<td class="prompt">Min data columns</td>
				<td>
					<input type="text" class="text" name="minDataColumns" size="12" maxlength="10"
						onkeypress="return Numbers.integerOnly(event)">
				</td>
			</tr>
			<tr valign="top">
				<td class="prompt">Data splitter regexp</td>
				<td>
					<table border="0" cellspacing="0" cellpadding="0">
					<tr>
					<td>
						<input type="text" class="text required" name="dataSplitter" size="40">&nbsp;
					</td>
					<td>
						<base:button title="Predefined&hellip;" 
							onclick="showPredefined(event, 'predefinedSplitters')" />
					</td>
					</tr>
					</table>
				</td>
				<td class="prompt">Max data columns</td>
				<td>
					<input type="text" class="text" name="maxDataColumns" size="12" maxlength="10"
						onkeypress="return Numbers.integerOnly(event)">
				</td>
			</tr>
			<tr valign="top">
				<td class="prompt">Ignore regexp</td>
				<td>
					<table border="0" cellspacing="0" cellpadding="0">
					<tr>
					<td>
						<input type="text" class="text" name="ignore" size="40">&nbsp;
					</td>
					<td>
						<base:button title="Predefined&hellip;" 
							onclick="showPredefined(event, 'predefinedIgnore')" />
					</td>
					</tr>
					</table>
				</td>
				<td class="prompt"><label for="trimQuotes">Remove quotes</label></td>
				<td><input type="checkbox" name="trimQuotes" id="trimQuotes" value="1"></td>
			</tr>
			<tr valign="top">
				<td class="prompt">Data header regexp</td>
				<td>
					<input type="text" class="text" name="dataHeader" size="40">
				</td>
			</tr>
			<tr valign="top">
				<td class="prompt">Data footer regexp</td>
				<td>
					<input type="text" class="text" name="dataFooter" size="40">
				</td>
			</tr>
			</table>
			<div align="right">&nbsp;<i><base:icon image="required.gif" /> = required information</i></div>
			
			<iframe name="parsed" id="idParsed" src="parse_file.jsp?ID=<%=ID%>" width="100%" 
				frameborder="0" vspace="0" hspace="0"
				marginwidth="0" marginheight="0" scrolling="no" style="overflow: hidden;;"></iframe>
			
			
		</div>
		</form>
	
		<table align="center">
		<tr>
			<td width="50%"><base:button onclick="saveSettings();" title="Ok" /></td>
			<td width="50%"><base:button onclick="window.close();" title="Cancel" /></td>
		</tr>
		</table>
	</base:body>
	</base:page>
	<%
}
finally
{
	if (dc != null) dc.close();
}
%>

