<%-- $Id: select_color.jsp 5426 2010-09-24 09:18:50Z nicklas $
	------------------------------------------------------------------
	Copyright (C) 2006 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

	A window for selecting a color interactively from a color chart.

	@param title The title of the input field on the parent form
	@param form The name of the form where the input field is located
	@param input The name of the input field containing the current color value
	@param callback A javascript function to call to set the new color in the
		opener's form (optional, if not specified the color is just saved back to
		the original form)

	@author Nicklas
	@version 2.0
--%>
<%@ page pageEncoding="UTF-8" session="false"
	import="net.sf.basedb.util.Values"
	import="java.util.Date"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%
	String title = request.getParameter("title");
	String form = request.getParameter("form");
	String input = request.getParameter("input");
	String callback = request.getParameter("callback");
%>
<base:page type="popup" title="<%=title%>">
<base:head styles="colorchart.css">
	<script language="JavaScript">
	function init()
	{
		var color = getColor();
		var frm = document.forms['color'];
		if (color && color.length == 4)
		{
			frm.red.value = color[1];
			frm.green.value = color[2];
			frm.blue.value = color[3];
		}
	}
	
	function getColor()
	{
		var frm = window.opener.document.forms['<%=form%>'];
		var colorString = frm['<%=input%>'].value;
		var colors = colorString.match('([0-9A-Fa-f]{2})([0-9A-Fa-f]{2})([0-9A-Fa-f]{2})');
		return colors;
	}
	
	function validateColor(color)
	{
		return color.match('[0-9A-Fa-f]{2}');
	}
	
	function setColor()
	{
		var frm = document.forms['color'];
		if (!validateColor(frm.red.value))
		{
			alert('Invalid red color value');
			frm.red.focus();
			return;
		}
		else if (!validateColor(frm.green.value))
		{
			alert('Invalid green color value');
			frm.green.focus();
			return;
		}
		else if (!validateColor(frm.blue.value))
		{
			alert('Invalid blue color value');
			frm.blue.focus();
			return;
		}
		
		var theColor = frm.red.value + frm.green.value + frm.blue.value;
		<%
		if (callback == null)
		{
			%>
			var frm = window.opener.document.forms['<%=form%>'];
			frm['<%=input%>'].value = theColor;
			<%
		}
		else
		{
			%>
			window.opener.<%=callback%>('<%=form%>', '<%=input%>', theColor);
			<%
		}
		%>
		window.close();
	}
	
	function colorOnClick(r, g, b)
	{
		var frm = document.forms['color'];
		frm.red.value = r;
		frm.green.value = g;
		frm.blue.value = b;
	}
	</script>
</base:head>
<base:body onload="init()">
	<form name="color">
	<h3 class="docked"><%=title%><base:help helpid="colorchart.selectcolor" /></h3>
	<div class="boxed">

		<table border=0 cellspacing=1 cellpadding=0 class="colorchart" align="center">
		<%
		int cells = 0;
		for (int red = 0; red < 16; red += 3)
		{
			String r = Integer.toHexString(red).toUpperCase();
			for (int green = 0; green < 16; green += 3)
			{
				String g = Integer.toHexString(green).toUpperCase();
				for (int blue = 0; blue < 16; blue += 3)
				{
					String b = Integer.toHexString(blue).toUpperCase();
					if (cells == 0)
					{
						%>
						<tr>
						<%
					}
					cells++;
					%>
					<td><div class="colorbox link" style="background: #<%=r+g+b%>"
						onclick="colorOnClick('<%=r+r%>', '<%=g+g%>', '<%=b+b%>')"
						></div></td>
					<%
					if (cells == 18)
					{
						cells = 0;
						%>
						</tr>
						<%
					}
				}
			}
		}
		%>
		</table>
		<table class="form" align="center">
		<tr>
			<td class="prompt">Red</td>
			<td><input class="text" type="text" name="red" value="" size="2" maxlength="2"></td>

			<td class="prompt">Green</td>
			<td><input class="text" type="text" name="green" value="" size="2" maxlength="2"></td>

			<td class="prompt">Blue</td>
			<td><input class="text" type="text" name="blue" value="" size="2" maxlength="2"></td>
		</tr>
		</table>

	</div>
	</form>
	<table align="center">
	<tr>
		<td><base:button onclick="setColor()" title="Ok" /></td>
		<td><base:button onclick="window.close()" title="Cancel" /></td>
	</tr>
	</table>
</base:body>
</base:page>
